"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "getPrepareQueryHandler", {
    enumerable: true,
    get: ()=>getPrepareQueryHandler
});
const _errorHandlerJs = require("../errorHandler.js");
const _getQuerySchemaJs = require("../getQuerySchema.js");
function getPrepareQueryHandler(options) {
    const errorHandler = (0, _errorHandlerJs.getErrorHandler)(options);
    const fn = function prepareQuery(req, res, next) {
        req.erm = req.erm || {};
        try {
            req.erm.query = (0, _getQuerySchemaJs.getQueryOptionsSchema)({
                allowRegex: options.allowRegex
            }).parse(req.query || {});
            next();
        } catch (e) {
            return errorHandler(new Error("invalid_json_query"), req, res, next);
        }
    };
    return fn;
}
