import { getErrorHandler } from "../errorHandler.js";
import { getQueryOptionsSchema } from "../getQuerySchema.js";
export function getPrepareQueryHandler(options) {
    const errorHandler = getErrorHandler(options);
    const fn = function prepareQuery(req, res, next) {
        req.erm = req.erm || {};
        try {
            req.erm.query = getQueryOptionsSchema({
                allowRegex: options.allowRegex
            }).parse(req.query || {});
            next();
        } catch (e) {
            return errorHandler(new Error("invalid_json_query"), req, res, next);
        }
    };
    return fn;
}
